package ShortestPath;

import java.util.Vector;

public class TestShortestPath {

	public static void main(String[] args)
	{
		// this is the graph from the shortest path flash card
		Graph graph = new Graph();
		graph.AddNode("a");
		graph.AddNode("b");
		graph.AddNode("c");
		graph.AddNode("d");
		graph.AddNode("e");
		graph.AddNode("f");
		graph.AddNode("g");
		graph.AddNode("h");
		graph.AddNode("i");
		graph.AddNode("j");
		graph.AddNode("z");
		graph.AddEdge("a","b",1);
		graph.AddEdge("a","c",4);		
		
		graph.AddEdge("b","d",3);
		graph.AddEdge("b","c",2);
		graph.AddEdge("b","e",6);
		
		graph.AddEdge("c","b",2);
		graph.AddEdge("c","e",4);
		graph.AddEdge("c","f",2);
		graph.AddEdge("c","h",2);
		
		graph.AddEdge("d","b",3);
		graph.AddEdge("d","e",5);
		graph.AddEdge("d","g",7);		
		graph.AddEdge("d","i",6);
		
		graph.AddEdge("e","b",6);
		graph.AddEdge("e","d",5);
		graph.AddEdge("e","g",3);
		graph.AddEdge("e","h",1);
		graph.AddEdge("e","c",4);

		graph.AddEdge("f","c",2);
		graph.AddEdge("f","h",1);
		graph.AddEdge("f","j",6);

		graph.AddEdge("g","d",7);
		graph.AddEdge("g","i",2);
		graph.AddEdge("g","z",4);
		graph.AddEdge("g","h",5);
		graph.AddEdge("g","e",1);

		
		graph.AddEdge("h","e",1);
		graph.AddEdge("h","g",5);
		graph.AddEdge("h","z",11);
		graph.AddEdge("h","j",7);
		graph.AddEdge("h","f",1);
		graph.AddEdge("h","c",2);

		graph.AddEdge("i","d",6);
		graph.AddEdge("i","g",2);
		graph.AddEdge("i","z",5);

		graph.AddEdge("j","f",6);
		graph.AddEdge("j","h",7);
		graph.AddEdge("j","z",3);
		
		System.out.println("computing shortest path");
		
		Vector<Node> path = graph.ShortestPath(graph.FindNode("a"), graph.FindNode("z"));
		for (int i = path.size()-1; i>=0; --i)
		{
			Node n = path.get(i);
			n.print();
		}
		System.out.println();
	}
	
}
